SystemOrganization addCategory: #'SourceCity-Layout'!

Object subclass: #SourceCityAbstractLayout
	instanceVariableNames: 'gap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Layout'!

!SourceCityAbstractLayout commentStamp: 'DouailleErwan 8/9/2012 14:56' prior: 0!
SourceCityAbstractLayout is an Abstract for each Layout class of SourceCity!

!SourceCityAbstractLayout class methodsFor: 'instance creation' stamp: 'DouailleErwan 8/9/2012 14:32'!
gap: anObject
	^self new gap: anObject! !

!SourceCityAbstractLayout class methodsFor: 'instance creation' stamp: 'DouailleErwan 8/3/2012 10:52'!
new
	^self basicNew initialize! !

!SourceCityAbstractLayout methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 13:59'!
gap
	^ gap! !

!SourceCityAbstractLayout methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 13:59'!
gap: anObject
	gap := anObject! !

!SourceCityAbstractLayout methodsFor: 'initialize-release' stamp: 'DouailleErwan 8/9/2012 14:36'!
initialize
	super initialize.! !

!SourceCityAbstractLayout methodsFor: 'layout' stamp: 'DouailleErwan 8/9/2012 13:47'!
layoutCollection: aCollection origin: aPosition 
	^self subclassResponsibility! !

!SourceCityAbstractLayout methodsFor: 'layout' stamp: 'DouailleErwan 8/9/2012 14:35'!
maxDimensionFor: aCollection
	^Point3D x: (aCollection inject: 0 into: [:maxX :each | maxX max: each dimension x])
		y: (aCollection inject: 0 into: [:maxY :each | maxY max: each dimension y])
		z: (aCollection inject: 0 into: [:maxZ :each | maxZ max: each dimension z])! !

SourceCityAbstractLayout subclass: #SourceCitySquareLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Layout'!

!SourceCitySquareLayout commentStamp: 'DouailleErwan 8/9/2012 14:56' prior: 0!
SourceCitySquareLayout optimal layout for a square render!

!SourceCitySquareLayout methodsFor: 'layout' stamp: 'DouailleErwan 8/9/2012 15:11'!
containerSize: aCollection
	^Point3D x: (aCollection inject: 0 into: [:maxX :each | maxX max: (each position x + each dimension x)])
		y: (aCollection inject: 0 into: [:maxY :each | maxY max: each dimension y])
		z: (aCollection inject: 0 into: [:maxZ :each | maxZ max: (each position z + each dimension z)])! !

!SourceCitySquareLayout methodsFor: 'layout' stamp: 'DouailleErwan 8/10/2012 16:07'!
createTreeFor: aCollection originPosition: aPosition 
	| root maxSize origin2D numberOfElement dimension |
	
	root := SourceCitySquareLayoutNode new.
	maxSize := self maxDimensionFor: aCollection.
	origin2D := (Point x: aPosition x y: aPosition z ).
	numberOfElement := aCollection size.
	dimension := Point x: ((maxSize x * numberOfElement * 10) + (self gap * (numberOfElement *10 - 1)))
		y:  ((maxSize z * numberOfElement * 10) + (self gap * (numberOfElement * 10 - 1))).
	root rectangle: (Rectangle origin: origin2D corner: origin2D + dimension).
	^SourceCitySquareLayoutTree newRoot: root! !

!SourceCitySquareLayout methodsFor: 'layout' stamp: 'DouailleErwan 8/12/2012 15:37'!
layoutCollection: aCollection origin: aPosition 
	| node tree aSortedCollection container|
	
	tree := self createTreeFor: aCollection originPosition: (Point3D x: 0 y: 0 z: 0).
	aSortedCollection := aCollection sort: [:a :b | a dimension x > b dimension x].
	aSortedCollection do: [:each |
		node := tree optimalInsert: each.
		node 
		ifNotNil: [| relativePosition |
			relativePosition := Point3D x: node rectangle origin x y: 2 z: node rectangle origin y.
			each position:  relativePosition]
		ifNil: [ ExampleBuilderMorph new abort: 'There is no free layout for: ' , each name].
		].
	^self containerSize: aCollection.! !

Object subclass: #SourceCitySquareLayoutNode
	instanceVariableNames: 'rectangle cityElement firstChild secondChild'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Layout'!

!SourceCitySquareLayoutNode commentStamp: 'DouailleErwan 8/9/2012 14:57' prior: 0!
SourceCitySquareLayoutNode is class for each node of SourceCitySquareLayoutTree !

!SourceCitySquareLayoutNode methodsFor: 'leaf-aggregation' stamp: 'DouailleErwan 8/9/2012 14:37'!
allFreeLeavesUnderneath
	| leaves |
	leaves := OrderedCollection new.
	self isLeaf 
	ifTrue: [self isFree ifTrue: [leaves add: self]]
	ifFalse: [
		firstChild isLeaf 
			ifTrue: [firstChild isFree ifTrue: [leaves add: firstChild]]
			ifFalse: [leaves addAll: firstChild allFreeLeavesUnderneath].
		secondChild isLeaf 
			ifTrue: [secondChild isFree ifTrue: [leaves add: secondChild]]
			ifFalse: [leaves addAll: secondChild allFreeLeavesUnderneath]].
	^leaves! !

!SourceCitySquareLayoutNode methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 14:15'!
cityElement
	^ cityElement! !

!SourceCitySquareLayoutNode methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 14:15'!
cityElement: anObject
	cityElement := anObject! !

!SourceCitySquareLayoutNode methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 14:15'!
firstChild
	^ firstChild! !

!SourceCitySquareLayoutNode methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 14:15'!
firstChild: anObject
	firstChild := anObject! !

!SourceCitySquareLayoutNode methodsFor: 'inserting' stamp: 'DouailleErwan 8/9/2012 14:27'!
insert: aCityElement
	self isLeaf
	ifTrue:
		[self isFree ifFalse: [^nil].
		(self isAnyFitFor: aCityElement) ifFalse: [^nil].
		(self isPerfectFitFor: aCityElement) ifTrue: [^self cityElement:  aCityElement].
		firstChild := self class new.
		secondChild := self class new.
		self splitFor: aCityElement.
		^firstChild insert: aCityElement]
	ifFalse:
		[| newNode |
		newNode := firstChild insert: aCityElement.
		newNode notNil
			ifTrue: [^newNode]
			ifFalse: [^secondChild insert: aCityElement]]! !

!SourceCitySquareLayoutNode methodsFor: 'querying' stamp: 'DouailleErwan 8/12/2012 15:35'!
isAnyFitFor: aCityElement 
	^rectangle width asFloat roundedUp >= (aCityElement dimension x asFloat roundedUp ) 
		and: [rectangle height asFloat roundedUp >= (aCityElement dimension z asFloat roundedUp )]! !

!SourceCitySquareLayoutNode methodsFor: 'querying' stamp: 'DouailleErwan 8/6/2012 11:21'!
isFree
	^cityElement isNil! !

!SourceCitySquareLayoutNode methodsFor: 'querying' stamp: 'DouailleErwan 8/3/2012 11:01'!
isLeaf
	^firstChild isNil and: [secondChild isNil]! !

!SourceCitySquareLayoutNode methodsFor: 'querying' stamp: 'DouailleErwan 8/9/2012 14:27'!
isPerfectFitFor: aCityElement 
	^rectangle width asFloat roundedUp = aCityElement dimension x asFloat roundedUp 
		and: [rectangle height asFloat roundedUp = aCityElement dimension z asFloat roundedUp ]! !

!SourceCitySquareLayoutNode methodsFor: 'printing' stamp: 'DouailleErwan 8/9/2012 14:38'!
printOn: aStream 
	aStream
		nextPutAll: self rectangle printString;
		nextPutAll: (
			self isFree 
			ifTrue: ['(free)']
			ifFalse: [' (' , cityElement asString , ')'])! !

!SourceCitySquareLayoutNode methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 14:15'!
rectangle
	^ rectangle! !

!SourceCitySquareLayoutNode methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 14:15'!
rectangle: anObject
	rectangle := anObject! !

!SourceCitySquareLayoutNode methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 14:15'!
secondChild
	^ secondChild! !

!SourceCitySquareLayoutNode methodsFor: 'accessing' stamp: 'DouailleErwan 8/9/2012 14:15'!
secondChild: anObject
	secondChild := anObject! !

!SourceCitySquareLayoutNode methodsFor: 'inserting' stamp: 'DouailleErwan 8/9/2012 16:06'!
splitFor: aCityElement 
	(rectangle width - aCityElement dimension x) > (rectangle height - aCityElement dimension z) 
		ifTrue: [
			firstChild rectangle: (Rectangle 
				left: rectangle left
				right: rectangle left + aCityElement dimension x  
				top: rectangle top
				bottom: rectangle bottom).
			secondChild rectangle: (Rectangle 
				left: ((rectangle left + aCityElement dimension x   + 3) min: rectangle right)
				right: rectangle right
				top: rectangle top
				bottom: rectangle bottom)]
		ifFalse: [
			firstChild rectangle: (Rectangle 
				left: rectangle left
				right: rectangle right
				top: rectangle top
				bottom: rectangle top + aCityElement dimension z   ).
			secondChild rectangle: (Rectangle 
				left: rectangle left
				right: rectangle right
				top: ((rectangle top + aCityElement dimension z   + 3) min: rectangle bottom)
				bottom: rectangle bottom)
				].! !

Object subclass: #SourceCitySquareLayoutTree
	instanceVariableNames: 'root extent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Layout'!

!SourceCitySquareLayoutTree commentStamp: 'DouailleErwan 8/9/2012 14:58' prior: 0!
SourceCitySquareLayoutTree is a tree where each city element is layout. Use to square optimal layout!

!SourceCitySquareLayoutTree class methodsFor: 'instance creation' stamp: 'DouailleErwan 8/3/2012 11:00'!
newRoot: aNode
	^self basicNew initializeRoot: aNode! !

!SourceCitySquareLayoutTree methodsFor: 'leaf-aggregation' stamp: 'DouailleErwan 8/3/2012 16:16'!
allFreeLeaves
	^root allFreeLeavesUnderneath! !

!SourceCitySquareLayoutTree methodsFor: 'what-if' stamp: 'DouailleErwan 8/9/2012 14:17'!
cornerIf: aCityElement wereInNode: aNode
	^(aNode isAnyFitFor: aCityElement) 
		ifTrue: 
			[(aNode rectangle left + aCityElement dimension x) @ (aNode rectangle top + aCityElement dimension z)]
		ifFalse: [nil]! !

!SourceCitySquareLayoutTree methodsFor: 'accessing' stamp: 'DouailleErwan 8/3/2012 11:00'!
extent
	^extent! !

!SourceCitySquareLayoutTree methodsFor: 'accessing' stamp: 'DouailleErwan 8/3/2012 11:00'!
extent: anObject
	extent := anObject! !

!SourceCitySquareLayoutTree methodsFor: 'what-if' stamp: 'DouailleErwan 8/9/2012 14:24'!
globalExtentIf: aCityElement wereInNode: aNode 
	| localExtent |
	localExtent := self cornerIf: aCityElement wereInNode: aNode.
	^localExtent isNil ifTrue: [nil] ifFalse: [extent max: localExtent]! !

!SourceCitySquareLayoutTree methodsFor: 'initialize-release' stamp: 'DouailleErwan 8/3/2012 11:00'!
initializeRoot: aNode
	root := aNode.
	extent := 0@0.
	^self! !

!SourceCitySquareLayoutTree methodsFor: 'inserting' stamp: 'DouailleErwan 8/9/2012 14:45'!
optimalInsert: aCityElement 
	| fittingFreeLeaves extentPreserversToWastedSpaceDictionary extentModifiersToExtentDictionary node newExtent |
	
	fittingFreeLeaves := self allFreeLeaves select: [:each | each isAnyFitFor: aCityElement].
	extentPreserversToWastedSpaceDictionary := Dictionary new.
	extentModifiersToExtentDictionary := Dictionary new.
	fittingFreeLeaves do: [:each | 
		| potentialCorner |
		potentialCorner := self cornerIf: aCityElement wereInNode: each.
		(potentialCorner x > extent x or: [potentialCorner y > extent y]) 
		ifTrue: [
			| potentialExtent |
			potentialExtent := self globalExtentIf: aCityElement wereInNode: each.
			extentModifiersToExtentDictionary at: each put: potentialExtent]
		ifFalse: [
			| wastedSpace |
			wastedSpace := self wastedSpaceIf: aCityElement wereInNode: each.
			extentPreserversToWastedSpaceDictionary at: each put: wastedSpace]
		].
	extentPreserversToWastedSpaceDictionary notEmpty 
	ifTrue: [
		newExtent := extent.
		node := fittingFreeLeaves detect: [:each | extentPreserversToWastedSpaceDictionary keys includes: each].
		fittingFreeLeaves do: [:eachNode | 
			|eachWastedSpace minWastedSpace|	
			(extentPreserversToWastedSpaceDictionary keys includes: eachNode) ifTrue: [
			eachWastedSpace := extentPreserversToWastedSpaceDictionary at: eachNode.
			minWastedSpace := extentPreserversToWastedSpaceDictionary at: node.
			eachWastedSpace < minWastedSpace ifTrue: [node := eachNode]]	
			].]
		ifFalse: [
			node := fittingFreeLeaves detect: [:each | extentModifiersToExtentDictionary keys includes: each].
			fittingFreeLeaves do: [:eachNode |
				|eachExtent eachRatio minExtent minRatio|
				(extentModifiersToExtentDictionary keys includes: eachNode) 
				ifTrue: [
					eachExtent := extentModifiersToExtentDictionary at: eachNode.
					eachRatio := ((eachExtent x / eachExtent y max: eachExtent y / eachExtent x) - 1) abs.
					minExtent := extentModifiersToExtentDictionary at: node.
					minRatio := ((minExtent x / minExtent y max: minExtent y / minExtent x) - 1) abs.
					eachRatio < minRatio ifTrue: [node := eachNode]]	
				].
		newExtent := extentModifiersToExtentDictionary at: node.
		extent := newExtent].
	^node insert: aCityElement! !

!SourceCitySquareLayoutTree methodsFor: 'accessing' stamp: 'DouailleErwan 8/3/2012 11:00'!
root
	^root! !

!SourceCitySquareLayoutTree methodsFor: 'accessing' stamp: 'DouailleErwan 8/3/2012 11:00'!
root: anObject
	root := anObject! !

!SourceCitySquareLayoutTree methodsFor: 'what-if' stamp: 'DouailleErwan 8/9/2012 14:41'!
wastedSpaceIf: aCityElement wereInNode: aNode 
	^(aNode isAnyFitFor: aCityElement) 
	ifTrue: [(aNode rectangle width - aCityElement dimension x ) * (aNode rectangle height - aCityElement dimension z)]
	ifFalse: [nil]! !
